//+------------------------------------------------------------------+
//  Bolliinger Squeeze V8 Experiment 
//|
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+


extern bool UseHourTrade = true; // Time filter
extern int  FromHourTrade = 6; // start trading on this hour
extern int  ToHourTrade = 22; // end trading on this hour
extern bool UseLastPeriodPerams=false;// uses the high and low from last period for calculation


extern double TakeProfit = 277;
extern double Lots = 1.0;
extern double TrailingStop = 50;


// extern string note1 = "Filter the Bollinger Band with";
// extern string note2 = "1=Stoch; 2=CCI, 3=RSI";
extern int triggerType=1;
extern int stochPeriod_trigger1=14;
extern int cciPeriod_trigger2=50;
extern int rsiPeriod_trigger3=13;







//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
      
 
 
 double upB = iCustom(Symbol(),0,"Bollinger Squeeze v8", 1, 14, 50, 13, 0,1);
 double loB = iCustom(Symbol(),0,"Bollinger Squeeze v8", 1, 14, 50, 13, 1,1);
 double upB2 = iCustom(Symbol(),0,"Bollinger Squeeze v8", 1, 14, 50, 13, 2,1);
 double loB2 = iCustom(Symbol(),0,"Bollinger Squeeze v8", 1, 14, 50, 13, 3,1);
 double mm = iCustom(Symbol(),0,"Bollinger Squeeze v8", 1, 14, 50, 13, 4,1);
 double cciline = iCustom(Symbol(),0,"Bollinger Squeeze v8", 1, 14, 50, 13, 5,1);

 double M34EMA= iMA(NULL,0,34,0,MODE_EMA,PRICE_TYPICAL,0);
 
 
 
      
   string LastTradeTime=datetime;
   
   int cnt,ticket,tt=0, total;
   
// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }
// to simplify the coding and speed up access
// data are put into internal variables


   
  
   

   
 
   
   total=OrdersTotal();
   if(total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
 
 // check for long position (BUY) possibility
 
 if ( Close[1]<=M34EMA && Close [0]> M34EMA )  
        {
         Alert ("We have a 34 cross going up",Symbol());
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,Ask+TakeProfit*Point,"Go Long",16384,0,Blue);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
  
  
        
        
      // check for short position (SELL) possibility && 

if ( Close[1]>=M34EMA && Close[0]<M34EMA )

        {
         Alert ("We have a 34 cross going down",Symbol());
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,Bid-TakeProfit*Point,"Go Short",16384,0,Orange);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
        else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
     
     
     
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            
            // Check Buy position - should it be closed?   
            
         if(  Close[1]<M34EMA  ) 
         
                            {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                                
                  return(0); // exit
                  }
             
            
             
                  
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to check if short position should be closed 
           {
           
            // should it be closed?
             
           //   if ( ( CCI50<-280 && CCI21>-89 )  || ( RSI4<4.7 && RSI21<29.5  ) || ( Stoch<16.11)  )
             
             if(  Close[1]>M34EMA ) 
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Yellow); // close position
               return(0); // exit
               
              }
            // check for trailing stop
                        
            if(TrailingStop>0)  
              { 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
  }
// the end.